apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ matomo_name }}
  name: {{ matomo_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ matomo_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ matomo_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ matomo_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ matomo_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ matomo_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ matomo_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: APACHE_DOMAIN
          value: {{ matomo_fqdn }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: MATOMO_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ matomo_name }}
        - name: MATOMO_ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ matomo_name }}
        - name: MATOMO_HTTP_PORT
          value: "8080"
{% if matomo_db_type == 'percona' %}
        - name: MATOMO_MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mtpc_name }}
        - name: MATOMO_MYSQL_HOST
          value: {{ mtpc_name }}-client
        - name: MATOMO_MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mtpc_name }}
        - name: MATOMO_MYSQL_TABLE_PREFIX
          value: matomo_
        - name: MATOMO_MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mtpc_name }}
{% elif matomo_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MATOMO_MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mtms_name }}
        - name: MATOMO_MYSQL_HOST
          value: {{ mtms_name }}
        - name: MATOMO_MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mtms_name }}
        - name: MATOMO_MYSQL_TABLE_PREFIX
          value: matomo_
        - name: MATOMO_MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mtms_name }}
{% endif %}
        - name: MATOMO_ORG_NAME
          value: {{ matomo_org_name }}
        - name: OAUTH2_ID_MAP
{% if do_lemon %}
          value: sub
        - name: OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: matomo-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OAUTH2_SERVER_URL
          value: {{ lemon_portal }}
{% else %}
          value: ""
        - name: OAUTH2_SECRET
          value: ""
{% endif %}
        - name: OPENLDAP_BASE
{% if do_ldap %}
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=matomo,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: matomo-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USER_FILTER
{% if do_fusion %}
          value: "(&(objectClass=gosaAccount)(!(pwdAccountLockedTime=*)))"
{% else %}
          value: "(&(objectClass={{ matomo_ldap_user_objectclass }})(!(pwdAccountLockedTime=*)))"
{% endif %}
{% else %}
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USER_FILTER
          value: ""
{% endif %}
        - name: PHP_MAX_EXECUTION_TIME
          value: "{{ matomo_php_max_execution_time }}"
        - name: PHP_MEMORY_LIMIT
          value: {{ matomo_php_memory_limit }}
        - name: PUBLIC_PROTO
          value: https
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
{% endif %}
        - name: SMTP_MAIL_FROM
          value: matomo@{{ root_domain }}
        - name: SMTP_MAIL_NOREPLY
          value: noreply@{{ root_domain }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='matomo'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='matomo'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          httpGet:
            path: /js/piwik.min.js
            port: 8080
          initialDelaySeconds: 40
          periodSeconds: 20
          timeoutSeconds: 15
        name: matomo
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /js/piwik.min.js
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 13
        resources:
          limits:
            cpu: "{{ matomo_cpu_limit }}"
            memory: "{{ matomo_memory_limit }}"
          requests:
            cpu: "{{ matomo_cpu_request }}"
            memory: "{{ matomo_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: apachesites
          subPath: apache
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /usr/local/share/ca-certificates
          name: apachesites
          subPath: ca-certificates
        - mountPath: /var/www/html
          name: data
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ matomo_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: apachesites
      - name: data
        persistentVolumeClaim:
          claimName: {{ matomo_name }}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='matomo'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - matomo
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='matomo'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
